create table Lehrer(
	Name varchar(80),
	Age float,
	Adresse varchar(80),
	primary key (Name)
);

insert into Lehrer values('Meier', 35, 'Pfaffenhofen');
insert into Lehrer values('Schulze', 34, 'Freising');
insert into Lehrer values('Schmidt', 31, 'Dachau');
insert into Lehrer values('Huber', 34, 'Dachau');
insert into Lehrer values('Werner', 55, 'Freising');

create table Klasse(
	Name varchar(80),
	Groesse float,
	Klassleiter varchar(80),
	Klassensprecher varchar(80),
	primary key (Name),
	foreign key (Klassleiter) references Lehrer
);

insert into Klasse values('7d', 31, 'Schulze', 'Stefan');
insert into Klasse values('7c', 31, 'Meyer', 'Robin');
insert into Klasse values('6a', 33, 'Meier', 'Miriam');
insert into Klasse values('5e', 34, 'Schulte', 'Thomas');
insert into Klasse values('10b', 24, 'Glatt', 'Stefanie');

create table Schuler(
	Name varchar(80),
	Vorname varchar(80),
	Klasse varchar(80),
	Adresse varchar(80),
	Konfession varchar(80),
	primary key (Name,Vorname,Klasse),
	foreign key (Klasse) references Klasse
);

insert into Schuler values('Meier', 'Alex', '6a', 'Mnchen', 'ev');
insert into Schuler values('Schussel', 'Stefan', '7a', 'Mnchen', 'kath');
insert into Schuler values('Schmidt', 'Michael', '6a', 'Mnchen', 'ev');
insert into Schuler values('Fertig', 'Thomas', '7d', 'Freising', 'kath');
insert into Schuler values('Muffel', 'Matthias', '7c', 'Dachau', 'kath');
insert into Schuler values('Schulze', 'David', '5e', 'Mnchen', 'ev');
insert into Schuler values('Bustum', 'Bernd', '5e', 'Dachau', 'ev');
insert into Schuler values('Curios', 'Coletta', '5e', 'Dachau', 'ev');
insert into Schuler values('Schmidt', 'Stefan', '7d', 'Mnchen', 'ev');

create table unterrichtet(
	Klasse varchar(80),
	Lehrer varchar(80),
	Fach varchar(80),
	primary key (Klasse,Lehrer,Fach),
	foreign key (Klasse) references Klasse,
	foreign key (Lehrer) references Lehrer
);

insert into unterrichtet values('7d', 'Meier', 'Mathe');
insert into unterrichtet values('7c', 'Schulze', 'Deutsch');
insert into unterrichtet values('7d', 'Huber', 'Englisch');
insert into unterrichtet values('5e', 'Huber', 'Franzsisch');
insert into unterrichtet values('7d', 'Schulze', 'Deutsch');
insert into unterrichtet values('6a', 'Huber', 'Englisch');
insert into unterrichtet values('10b', 'Huber', 'Franzsisch');

